$regfile = "ATtiny24.dat"
$crystal = 4000000
$hwstack = 32
$swstack = 8
$framesize = 24


Const #100 = &B11111111 :
Const #87 = &B01111111:
Const #75 = &B01110111 :
Const #62 = &B01101101 :
Const #50 = &B11001100 :
Const #38 = &B00110010 :
Const #25 = &B00100001 :
Const #15 = &B00000011 :
Const #0 = &B00000000 :



 DdrA = &B01101111                                          '   A: 1 -  
PortA = &B00011111                                          '   A

 DdrB = &B00000000                                          '   B: 1 -  
PortB = &B00000100                                          '   A:




Declare Sub Lamp_ON
Declare Sub Lamp_OFF

Declare Sub Vent_ON
Declare Sub Vent_OFF

Declare Sub BlinkLamp(ByVal Cnt as Byte )


On Int0 Zerocr Nosave                                       '    INT0.     asm,   ,    

On OVF1 Timer1_int Nosave                                   '     1.     asm

Config Timer1 = Timer , Prescale = 256

Stop TIMER1

Lamp_OFF


Dim Flags As Byte
Dim State As Byte
Dim Posl As Byte
Dim L As Byte , Temp As Byte , Tmp as Byte

Dim Delit As Byte , Tick_CNT as Byte , Per_Cnt as Byte
Dim Second As Byte , Sec_Cnt as Byte
Dim Minut As Byte , Min_Cnt as Byte
Dim Hour As Byte

Dim LightLamp As Byte



Mcucr = &B00100001                                          'IDLE  , INT0 - Change

Stop AC
Stop ADC

Config Watchdog = 2048                                      '   2 
WDR
Stop WATCHDOG
WDR
Enable Int0
Enable OVF1
Enable Interrupts


If MCUSR.wdrf = 1 then Call BlinkLamp(4 )
If MCUSR.BORF = 1 then Call BlinkLamp(3)
If MCUSR.EXTRF = 1 then Call BlinkLamp(2 )
If MCUSR.POrf = 1 then Call BlinkLamp(1 )
Wait 1


$asm
    Ldi R31 , &HFF                                          '  ,       
    LDI R24,  &H82
    OUT Tcnt1H , R31
    OUT Tcnt1L , R24
$end asm
Start Timer1

wdr
Start WATCHDOG
wdr

Posl = 0

'============================ ======================================
Main:
WDR
$asm
    SLEEP
$end asm
WDR
if Flags.5 = 1 then Goto Main                               '   ,    -    
'  ....
 if Flags.0 = 1 AND State.0 = 0 then
  State.0 = 1                                               '    ""
  Waitms 500                                                ' ,     
  Flags.0 = 0                                               '   
  Min_Cnt = 20                                              ' 20 .
  Flags.1 = 0                                               '         
  Flags.7 = 0                                               '     (,   1.  . )
  Flags.2 = 0                                               '     
  Posl = 0                                                  '  
 end IF
  WDR
 if Flags.0 = 1 AND State.0 = 1 then                        '   
  State.0 = 0                                               '   ""
  Waitms 500                                                ' ,     
  Flags.0 = 0                                               '   
  If Min_Cnt > 17 then                                      '    3- ,      
   Min_Cnt = 0
   Posl = 0
  else
   Min_Cnt = 5                                              ' ,      5 
   Posl = #100
  end if
  Flags.1 = 1                                               '    
 end IF

 WDR
 if State.0 = 1 AND Min_Cnt = 1 AND Flags.7 = 0 then
   Call BlinkLamp(2 )                                       ' ,     .
   Flags.7 = 1
 end IF

 if State.0 = 1 AND Min_Cnt = 10 AND Flags.2 = 0 then       '  10       
   Posl = #50
   Flags.2 = 1
 end IF

  WDR

 if State.0 = 1 AND Min_Cnt = 0 then
  State.0 = 0
  Posl = 0                                                  ' ,   (    )
  Flags.7 = 0
 end IF

 if Flags.1 = 1 AND Min_Cnt = 0 then
   Posl = 0                                                 ',      .  
   Flags.1 = 0
 end IF

  WDR

If State.0 = 1 then Goto MAIN                               '    

if PINA.4 = 0 then
 LightLamp = 50
 Goto MAIN
else
 LightLamp = 100
end if

  WDR

Temp = Minut mod 15                                         '     15 

If Temp = 0 and Flags.1 = 0 then
  Min_Cnt = 3                                               ' 3   
  Flags.1 = 1
  Posl = #100
 end IF



Goto MAIN
'  ============================ ====================================== 


Zerocr:                                                     '        !

$asm
    Push R31                                                ' 
    In R31 , Sreg
    Push R31
    Push R24
    Push R25
'--  
    Lds R31 , {Per_Cnt}
    inc R31                                                 'Incr Per_Cnt
    Sts {Per_Cnt} , R31
$end Asm
if LightLamp = 100 and State.0 = 1 Then Lamp_ON             '   ""        
L = Posl And &B0000001                                      '    Posl=1
If L = 1 Then Vent_ON                                       '  
Rotate Posl , Right                                         '     
 Waitms 5                                                   '     ,    
Lamp_OFF                                                    '       5 
Vent_OFF

if LightLamp < 100 and State.0 = 1 Then
 Lamp_ON
 Waitus 300                                                 '        
 Lamp_OFF                                                   '
end if                                                      '
                                                            '
$asm                                                        '
    POP R25
    POP R24
    Pop R31
    Out Sreg , R31                                          ' 
    Pop R31
    reti
$end Asm
Return

'   1 (16- )
'       8 
'     4 /1024/125 (125 )
Timer1_int:
$asm
    Push R31                                                ' 
    In R31 , Sreg
    Push R31
    Push R24
'-----
    Ldi R31 , &HFF                                          ' 
    LDI R24,  &H82
    OUT Tcnt1H , R31
    OUT Tcnt1L , R24
'-----
    Lds R31 , {Delit}
    inc R31                                                 'Incr Delit
    Sts {Delit} , R31
    CPI R31, 25                                             'If Delit < 25 Then Goto INTT0_E
    brlo  LABEL_00
    CLR R31                                                 'Delit = 0
    Sts {Delit} , R31
'-----    5   
    Lds R31 , {Per_Cnt}                                     '     200 ?
    CLR R24
    Sts {Per_Cnt} , R24                                     '  Per_Cnt
    CPI R31, 17                                             '  17? (  19...20)
    BRSH CLRFLPW
'---  17
'    Flags.0 = 1                                             '    
'    Flags.5 = 1
    Lds R31 , {Flags}
    ORI R31,&B00100001
    Sts {Flags}, R31
    RJMP NEXT_TICK
CLRFLPW:
'    Flags.5 = 0                                             '   
    Lds R31 , {Flags}
    ANDI R31,&B11011111
    Sts {Flags}, R31
NEXT_TICK:
    Lds R31 , {Tick_CNT}
    inc R31
    Sts {Tick_CNT} , R31
    CPI R31, 5
    brlo  LABEL_00
    CLR R31                                                 'Delit = 0
    Sts {Tick_CNT} , R31
    RJMP LABEL_01
LABEL_00:
    RJMP INTT0_E
'-----    1   
LABEL_01:
    WDR
    Lds R31 , {Second}
    inc R31
    Sts {Second} , R31
    CPI R31, 60
    brlo  INTT0_E
    clr R31
    Sts {Second} , R31
'----    1   
    Lds R24 , {Min_Cnt}
    TST R24
    BREQ LABEL_02
    dec R24
    STS {Min_Cnt},R24
LABEL_02:
    Lds R31 , {Minut}
    inc R31
    Sts {Minut} , R31
    CPI R31, 60
    brlo  INTT0_E
    clr R31
    Sts {Minut} , R31
Intt0_e:
'$asm
    POP R24
    Pop R31
    Out Sreg , R31                                          ' 
    Pop R31
    reti
$end Asm
Return                                                      '   

' 
'----------------------------------------------------------------------------------
Sub Lamp_OFF
$asm
    in  R31,PORTA
    ORI R31,&B00000011
    OUT PORTA , R31
$end asm
End SUB
'----------------------------------------------------------------------------------
Sub Lamp_ON
$asm
    in   R31,PORTA
    ANDI R31,&B11111100
    OUT PORTA , R31
$end asm
End SUB
'----------------------------------------------------------------------------------

Sub BlinkLamp(ByVal Cnt as Byte )
 Tmp = State
do
 State.0 = 1
Waitms 250
 State.0 = 0
Waitms 150
Decr Cnt
loop until Cnt = 0
State = Tmp
end sub
'----------------------------------------------------------------------------------
Sub Vent_OFF
$asm
    in  R31,PORTA
    ORI R31,&B00001100
    OUT PORTA , R31
$end asm
End SUB
'----------------------------------------------------------------------------------
Sub Vent_ON
$asm
    in   R31,PORTA
    ANDI R31,&B11110011
    OUT PORTA , R31
$end asm
End SUB
